"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var registry_1 = require("./registry");
var express = require("express");
var chai_1 = require("chai");
var request = require("supertest");
var js_restful_1 = require("js-restful");
var util = require("./test-util.spec");
var anyBook = { a: 'b' };
var TestService = (function () {
    function TestService() {
    }
    TestService.prototype.get = function () {
        return [];
    };
    TestService.prototype.getError = function () {
        throw new Error('test error');
    };
    TestService.prototype.getWithAdditionalPath = function () {
        return [anyBook];
    };
    TestService.prototype.getBoolean = function () {
        return true;
    };
    TestService.prototype.getNothing = function () {
    };
    TestService.prototype.getNumber = function () {
        return 42;
    };
    TestService.prototype.getString = function () {
        return '42';
    };
    TestService.prototype.getWith3Param = function (id, plain, token) {
        return { id: id, plain: plain, token: token };
    };
    TestService.prototype.getWithNullParams = function (test) {
        return { test: test };
    };
    TestService.prototype.getWithParam = function (id) {
        return { id: id };
    };
    __decorate([
        js_restful_1.GET(),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], TestService.prototype, "get", null);
    __decorate([
        js_restful_1.GET(),
        js_restful_1.Path('/error'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], TestService.prototype, "getError", null);
    __decorate([
        js_restful_1.GET(),
        js_restful_1.Path('/archived'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], TestService.prototype, "getWithAdditionalPath", null);
    __decorate([
        js_restful_1.GET(),
        js_restful_1.Path('/return-a-boolean'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], TestService.prototype, "getBoolean", null);
    __decorate([
        js_restful_1.GET(),
        js_restful_1.Path('/return-nothing'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], TestService.prototype, "getNothing", null);
    __decorate([
        js_restful_1.GET(),
        js_restful_1.Path('/return-number'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], TestService.prototype, "getNumber", null);
    __decorate([
        js_restful_1.GET(),
        js_restful_1.Path('/return-string'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], TestService.prototype, "getString", null);
    __decorate([
        js_restful_1.GET(),
        js_restful_1.Path('/test/:id'),
        __param(0, js_restful_1.PathParam('id')), __param(1, js_restful_1.QueryParam('plain')), __param(2, js_restful_1.HeaderParam('token')),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Number, Boolean, String]),
        __metadata("design:returntype", void 0)
    ], TestService.prototype, "getWith3Param", null);
    __decorate([
        js_restful_1.GET(),
        js_restful_1.Path('/stringtest'),
        __param(0, js_restful_1.QueryParam('test')),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [String]),
        __metadata("design:returntype", void 0)
    ], TestService.prototype, "getWithNullParams", null);
    __decorate([
        js_restful_1.GET(),
        js_restful_1.Path('/:id'),
        __param(0, js_restful_1.PathParam('id')),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Number]),
        __metadata("design:returntype", void 0)
    ], TestService.prototype, "getWithParam", null);
    TestService = __decorate([
        js_restful_1.Path('/books')
    ], TestService);
    return TestService;
}());
var TestServiceB = (function () {
    function TestServiceB() {
    }
    TestServiceB.prototype.get = function () {
        return [];
    };
    __decorate([
        js_restful_1.GET(),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], TestServiceB.prototype, "get", null);
    return TestServiceB;
}());
describe('service-registry: HTTP GET methods', function () {
    var app;
    var testService;
    var testServiceB;
    beforeEach(function () {
        app = express();
        testService = new TestService();
        testServiceB = new TestServiceB();
        var registry = new registry_1.JsRestfulRegistry(app);
        registry.registerService(testService);
        registry.registerService(testServiceB);
    });
    it('should test a GET method without a path', function (done) {
        request.agent(app).get('/books').end(function (err, res) {
            util.checkDefaultsJson(err, res, done);
            chai_1.expect(res.body).to.eql([]);
            done();
        });
    });
    it('should send an error if the service method throws an error', function (done) {
        request.agent(app).get('/books/error').end(function (err, res) {
            chai_1.expect(res.status).to.equal(500);
            chai_1.expect(JSON.stringify(res.error)).to.contains('test error');
            done();
        });
    });
    it('should test a GET method with a path', function (done) {
        request.agent(app).get('/books/archived').end(function (err, res) {
            util.checkDefaultsJson(err, res, done);
            chai_1.expect(res.body).to.eql([anyBook]);
            done();
        });
    });
    it('should test a GET method that returns a boolean', function (done) {
        request.agent(app).get('/books/return-a-boolean').end(function (err, res) {
            util.checkDefaultsText(err, res, done);
            chai_1.expect(res.text).to.eql('true');
            done();
        });
    });
    it('should test a GET method that returns  nothing', function (done) {
        request.agent(app).get('/books/return-nothing').end(function (err, res) {
            util.checkDefaultsText(err, res, done);
            chai_1.expect(res.text).to.eql('');
            done();
        });
    });
    it('should test a GET method that returns a number', function (done) {
        request.agent(app).get('/books/return-number').end(function (err, res) {
            util.checkDefaultsText(err, res, done);
            chai_1.expect(res.text).to.eql('42');
            done();
        });
    });
    it('should test a GET method that returns a string', function (done) {
        request.agent(app).get('/books/return-string').end(function (err, res) {
            util.checkDefaultsText(err, res, done);
            chai_1.expect(res.text).to.eql('42');
            done();
        });
    });
    it('should deal with services with no provided path as the default path', function (done) {
        request.agent(app).get('/').end(function (err, res) {
            util.checkDefaultsJson(err, res, done);
            chai_1.expect(res.body).to.eql([]);
            done();
        });
    });
    it('should test a GET method with a path and three params', function (done) {
        request.agent(app)
            .get('/books/test/1?plain=true')
            .set('token', 'token-value')
            .end(function (err, res) {
            util.checkDefaultsJson(err, res, done);
            // now it should not be a number - it should be a string
            chai_1.expect(res.body).to.eql({ id: 1, plain: true, token: "token-value" });
            done();
        });
    });
    it('should call a GET method with paramater type string if there is no type information available', function (done) {
        // remove the type annotations from the method in question
        var r = Reflect.defineMetadata('design:paramtypes', null, testService, 'getWithParam');
        request.agent(app)
            .get('/books/1')
            .end(function (err, res) {
            util.checkDefaultsJson(err, res, done);
            // now it should not be a number - it should be a string
            chai_1.expect(res.body).to.eql({ id: "1" });
            done();
        });
    });
    it('should provide null if the parameter value is not set and not try to convert it to String', function (done) {
        request.agent(app)
            .get('/books/test/1?plain=')
            .end(function (err, res) {
            util.checkDefaultsJson(err, res, done);
            // now it should not be a number - it should be a string
            chai_1.expect(res.body).to.eql({ id: 1, plain: false, token: null });
            done();
        });
    });
    it('should provide null if the parameter value is not set and not try to convert it to String', function (done) {
        request.agent(app)
            .get('/books/test/1')
            .end(function (err, res) {
            util.checkDefaultsJson(err, res, done);
            // now it should not be a number - it should be a string
            chai_1.expect(res.body).to.eql({ id: 1, plain: null, token: null });
            done();
        });
    });
    it('should provide null if the parameter value is not set - for string', function (done) {
        request.agent(app)
            .get('/books/stringtest')
            .end(function (err, res) {
            util.checkDefaultsJson(err, res, done);
            // it should not be "undefined"
            chai_1.expect(res.body).to.eql({ test: null });
            done();
        });
    });
    it('should provide an empty string if the parameter is set but the value is not set - for string', function (done) {
        request.agent(app)
            .get('/books/stringtest?test')
            .end(function (err, res) {
            util.checkDefaultsJson(err, res, done);
            // it should not be "undefined"
            chai_1.expect(res.body).to.eql({ test: '' });
            done();
        });
    });
    it('should provide an empty string if the parameter is set but the value is not set + = sign - for string', function (done) {
        request.agent(app)
            .get('/books/stringtest?test=')
            .end(function (err, res) {
            util.checkDefaultsJson(err, res, done);
            // it should not be "undefined"
            chai_1.expect(res.body).to.eql({ test: '' });
            done();
        });
    });
});
//# sourceMappingURL=registry-get.spec.js.map