"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var express = require("express");
var chai_1 = require("chai");
var request = require("supertest");
var decorators_1 = require("./decorators");
var renderers_1 = require("./renderers");
var registry_1 = require("./registry");
var js_restful_1 = require("js-restful");
var util = require("./test-util.spec");
var TestService = (function () {
    function TestService() {
    }
    TestService.prototype.render = function () {
        return { a: 'b' };
    };
    TestService.prototype.get = function () {
        return { a: 'b' };
    };
    __decorate([
        js_restful_1.Path('/'),
        js_restful_1.GET(),
        decorators_1.RenderWith('index'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], TestService.prototype, "render", null);
    __decorate([
        js_restful_1.GET(),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], TestService.prototype, "get", null);
    return TestService;
}());
describe('renderer', function () {
    var service = new TestService();
    var descriptions = js_restful_1.ServiceParser.parse(service);
    it('shoud return the default renderer for the get methods', function () {
        var renderer = renderers_1.RendererFactory.getRenderer(service, descriptions.getMethodDescriptorForMethodName('get'));
        chai_1.expect(renderer instanceof renderers_1.DefaultRenderer).to.be.true;
    });
    it('shoud return the renderwith renderer for the render methods', function () {
        var renderer = renderers_1.RendererFactory.getRenderer(service, descriptions.getMethodDescriptorForMethodName('render'));
        chai_1.expect(renderer instanceof renderers_1.RenderWithRenderer).to.be.true;
    });
});
describe('RenderWithRenderer', function () {
    var app = express();
    app.set('view engine', 'pug');
    app.set('views', __dirname + '/testviews');
    var registry = new registry_1.JsRestfulRegistry(app);
    registry.registerService(new TestService());
    it('should test a render method', function (done) {
        request.agent(app).get('/').end(function (err, res) {
            util.checkHttpStatus(err, res, done);
            chai_1.expect(res.text).to.eql('<div>a b</div>');
            done();
        });
    });
});
//# sourceMappingURL=renderers.spec.js.map